#ifndef _ygGrid_h_
#define _ygGrid_h_

#include "ygNode.h"

#define DRAW_OFF 0
#define DRAW_ON 1
#define DRAW_LOCAL 2
#define DRAW_REMOTE 3

class pfGeode;
class pfGeoSet;

class ygGrid : public ygNode
    {
    public:
     ygGrid(const char* name,bool master=true);
     ~ygGrid(void);
     virtual void reset(void);
     virtual void message(const ygMessage&);
     virtual void app(void);
     void setDraw(int);
     void filterMessage(const ygMessage&);
    protected:
     virtual void updateDebug(void);
    private:
     void createGeometry(void);
     void makeGridGeosets(void);
     void updateReference(void);
     pfGeode* geode;
     int numVerts;
     pfGeoSet* refGset;
     pfVec3* reference;
     float spacing;
     float length;
     float snapGrid;
     float snapRotate;
     int axis;
     int draw;
     ygString nodeName;
     ygNode* node;
     ygString filterMessages;
    };

extern "C" ygNode* construct_ygGrid(const char*,bool);

#endif
